variables:
  # This will supress any download for dependencies and plugins or upload messages which would clutter the console log.
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
  # when running from the command line.
  # `installAtEnd` and `deployAtEnd` are only effective with recent version of the corresponding plugins.
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"
  APP_NAME: bank-kata-backend


stages:
  - compile unit test and code quality analysis
  - build image
  - deploy to staging
  - functional test
  - non functional test
  - clean up staging
  - deploy to cloud prod

Compile:
  stage: compile unit test and code quality analysis
  image: maven:3.6.3-openjdk-8-slim
  script:
    - echo "Maven tasks"
    - mvn verify  $MAVEN_CLI_OPTS
    #- mvn sonar:sonar -Dsonar.login=$SONAR_LOGIN -Dsonar.projectKey=bankkata -Dsonar.host.url=https://[HOST_URL] -Dsonar.coverage.jacoco.xmlReportPaths=bankkata-infra-application/target/site/jacoco-aggregate/jacoco.xml
  artifacts:
    paths:
      - bankkata-infra-application/target/*.jar
      - bankkata-domain/target/*.jar
    reports:
     junit:
       - bankkata-domain/target/surefire-reports/TEST-*.xml
       - bankkata-infra-application/target/surefire-reports/TEST-*.xml



Image building:
  stage: build image
  image: docker:stable
  variables:
    DOCKER_TLS_CERTDIR: ""
    DOCKER_HOST: tcp://localhost:2375
  services:
    - docker:stable-dind
  before_script:
    - docker info
  script:
    - docker build -t $CI_REGISTRY_IMAGE .
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker push $CI_REGISTRY_IMAGE

Staging deployment:
  stage: deploy to staging
  environment: staging
  image: bitnami/kubectl:latest
  rules:
    - when: manual
  script:
    - sed -i "s|<APP_NAME>|$APP_NAME|g" deployment.yml
    - sed -i "s|<IMAGE_NAME>|$CI_REGISTRY_IMAGE|g" deployment.yml
    - cat deployment.yml
    - echo "Deploying to staging environment in Kubernetes cluster"
    - kubectl create secret docker-registry gitlab-registry --docker-server="$CI_REGISTRY" --docker-username="$CI_REGISTRY_USER" --docker-password="$CI_REGISTRY_PASSWORD" --docker-email="$GITLAB_USER_EMAIL"  -n demo | kubectl apply -f deployment.yml
    - sleep 20
    - service_address=$(kubectl get svc $APP_NAME -n demo --output jsonpath='{.status.loadBalancer.ingress[0].ip}')


Integration Testing:
  stage: functional test
  environment: staging
  script:
    - echo "Testing integration with other systems"

Non Regression Testing:
  stage: functional test
  environment: staging
  script:
    - echo "Testing for regression"

Acceptance Testing:
  stage: functional test
  environment: staging
  script:
    - echo "acceptance testing"

Load Testing:
  stage: non functional test
  environment: staging
  script:
    - echo "Load testing"

Dynamic Security Testing:
  stage: non functional test
  environment:
    staging
  script:
    - echo "Testing for security issues"

Clean-up staging environment:
  stage: clean up staging
  environment: staging
  image: bitnami/kubectl:latest
  script:
    - echo "Decommissioning resources"
    - sleep 60
    - kubectl delete deployment,svc $APP_NAME -n demo
    - kubectl delete secret gitlab-registry -n demo

Deploying to production:
  stage: deploy to cloud prod
  script:
    - echo "Deploying to Cloud"
